#include "ViewBase.h"

#include <QEvent>
#include <QKeyEvent>
#include <QTabletEvent>
#include <QMouseEvent>
#include <QMouseEvent>
#include <QMouseEvent>
#include <QLayout>

#include <QtDebug>

ViewBase::ViewBase( ViewBase::ViewMode aMode, QWidget *aParent ) : QWidget( aParent ), iViewMode( aMode )
{
	connectedOnce = false;
	connectionError = false;
}

ViewBase::~ViewBase()
{
	
}

ViewBase::ViewMode ViewBase::viewMode()
{
	return iViewMode;
}

void ViewBase::connectionEstablished()
{
	connectedOnce = true;
	connectionError = false;
}

void ViewBase::connectionLost()
{
	connectionError = true;
}


bool ViewBase::event(QEvent *event)
{
	switch( event->type() )
	{
		// TODO : Add events as needed !!!
		case QEvent::KeyPress:
		case QEvent::KeyRelease:
		case QEvent::TabletMove:
		case QEvent::TabletPress:
		case QEvent::MouseMove:
		case QEvent::MouseButtonPress:
		case QEvent::MouseButtonDblClick:
			emit eventDetected();
			break;
		default:
			break;
	}
	
	return QWidget::event( event );
}

bool ViewBase::eventFilter( QObject *watched, QEvent *event )
{
	if ( watched != this ) // We do not filter our own events
	{
		switch( event->type() )
		{
			// TODO : Add events as needed !!!!
			case QEvent::KeyPress:
			case QEvent::KeyRelease:
			case QEvent::TabletMove:
			case QEvent::TabletPress:
			case QEvent::MouseMove:
			case QEvent::MouseButtonPress:
			case QEvent::MouseButtonDblClick:
				emit eventDetected();
				break;
			default:
				break;
		}
	}
	
	return QWidget::eventFilter( watched, event );
}

void ViewBase::observeChild(QWidget *aChild)
{
	aChild->setMouseTracking( true );
	aChild->installEventFilter( this );
}
