#include <iostream>
#include <fstream> 
#include <QApplication>
#include <QTime>
#include "Engine.h"

using namespace std;

ofstream logfile;

void DebugOutputHandler( QtMsgType type, const char *msg ) {
    switch( type ) {
        case QtDebugMsg:
            logfile << QTime::currentTime().toString().toAscii().data() << " Debug: " << msg << "\n";
            logfile.flush();
            break;
        case QtCriticalMsg:
            logfile << QTime::currentTime().toString().toAscii().data() << " Critical: " << msg << "\n";
            logfile.flush();
            break;
        case QtWarningMsg:
            logfile << QTime::currentTime().toString().toAscii().data() << " Warning: " << msg << "\n";
            logfile.flush();
            break;
        case QtFatalMsg:
            logfile << QTime::currentTime().toString().toAscii().data() <<  " Fatal: " << msg << "\n";
            logfile.flush();
    }
}

int main( int argc, char *argv[] )
{
	#ifdef DEBUG_OUTPUT_TO_FILE
	logfile.open( "/usr/var/qtmeetings.log", ios::app );
	qInstallMsgHandler( DebugOutputHandler );
	#endif
	
	QApplication app( argc, argv );
	Engine *engine = new Engine;
	return app.exec();
}
